CLS
PRINT "FFC Barograph retrieval tool"
PRINT "============================"
PRINT
PRINT "IMPORTANT - WILL OVERWRITE FILES BAROm_nn.TXT"
PRINT
PRINT "Retrieve how many traces  ";
INPUT howmany
IF howmany = 0 THEN PRINT "All done then, bye!": END

PRINT "Starting with which trace ";
INPUT starttrace
IF starttrace = 0 THEN starttrace = 1

PRINT "From memory 1 or memory 2  ? ";
DO
  mem$ = INKEY$
LOOP UNTIL mem$ = "1" OR mem$ = "2"
PRINT mem$


' Open com port ...

PRINT
PRINT
PRINT "Waiting for comms to FFC ..."
PRINT
OPEN "COM1:19200,N,8,1,CD0,CS0,DS0,OP0,RS,TB2048,RB2048" FOR RANDOM AS #1


' Retrieve barographs ...

FOR n = starttrace TO (starttrace + howmany - 1)

  ' Open file for output
  file$ = STR$(n)
  file$ = RIGHT$(file$, LEN(file$) - 1)
  IF LEN(file$) = 1 THEN file$ = "0" + file$
  file$ = "baro" + mem$ + "_" + file$ + ".txt"
  OPEN file$ FOR OUTPUT AS #2
  

  ' Read in trace
  finished = 0
  PRINT #1, "SEND "; mem$; STR$(n)
  LINE INPUT #1, line$
  LINE INPUT #1, line$
  DO
    LINE INPUT #1, line$
    line$ = RIGHT$(line$, LEN(line$) - 1)
    IF line$ = "Done." THEN
      finished = 1
    ELSE
      PRINT #2, line$
    END IF
  LOOP UNTIL (finished = 1)

  ' Close output file
  
  CLOSE #2

NEXT n

CLOSE #1

PRINT "Done."

END

