CLS
PRINT "FFC Calibration tool"
PRINT "===================="
PRINT
PRINT "Waiting for comms to FFC ..."
PRINT

' Open com port ...

OPEN "COM1:19200,N,8,1,CD0,CS0,DS0,OP0,RS,TB2048,RB2048" FOR RANDOM AS #1


' Read current setting for m

PRINT #1, "RD 00 04"
GOSUB readresponse
hxnum$ = value$

PRINT #1, "RD 00 05"
GOSUB readresponse
hxnum$ = hxnum$ + value$

PRINT #1, "RD 00 06"
GOSUB readresponse
hxnum$ = hxnum$ + value$

GOSUB float2number
m# = number#


' Read current setting for c

PRINT #1, "RD 00 07"
GOSUB readresponse
hxnum$ = value$

PRINT #1, "RD 00 08"
GOSUB readresponse
hxnum$ = hxnum$ + value$

PRINT #1, "RD 00 09"
GOSUB readresponse
hxnum$ = hxnum$ + value$

GOSUB float2number
c# = number#


PRINT "Current settings:  m = "; m#; "  c = "; c#
PRINT
PRINT "Taking ten adc readings get ... ";


' Read adc

adcAverage = 0
FOR n = 1 TO 10
  PRINT #1, "ADC 1 0"
  GOSUB readresponse
  hl = 4
  hx$ = value$
  GOSUB gethexnum
  adcAverage = adcAverage + number
NEXT n
adcAverage = adcAverage / 10

PRINT HEX$(adcAverage)
pressure# = m# * adcAverage + c#

PRINT "making the pressure =  m * adc + c"
PRINT "                    = "; pressure#; "mbar"

PRINT
PRINT
PRINT "Would you like to supply recalibration values?  You will need adc readings"
PRINT "taken on a low pressure and a high pressure day."
PRINT

DO
  i$ = LCASE$(INKEY$)
LOOP UNTIL i$ = "y" OR i$ = "n"

IF i$ = "y" THEN
  PRINT "Yes"
  PRINT
ELSE
  PRINT "No"
  PRINT
  PRINT "Goodbye ..."
  END
END IF

PRINT "Please input the low pressure you took an adc reading at  ";
INPUT lowPressure
PRINT "Please input the (hex) adc reading you had                ";
INPUT hx$
hl = 4
GOSUB gethexnum
lowAdc = number

PRINT
PRINT "Please input the high pressure you took an adc reading at ";
INPUT highPressure
PRINT "Please input the (hex) adc reading you had                ";
INPUT hx$
hl = 4
GOSUB gethexnum
highAdc = number

m# = (highPressure - lowPressure) / (highAdc - lowAdc)
c# = lowPressure - (lowAdc * m#)

num# = m#
GOSUB number2float
hxm$ = hx$

num# = c#
GOSUB number2float
hxc$ = hx$

PRINT
PRINT
PRINT "Calibrated m would be "; m#; " ("; hxm$; ")"
PRINT "Calibrated c would be "; c#; " ("; hxc$; ")"
PRINT
PRINT "Would you like to commit to FFC memory? ";

DO
  i$ = LCASE$(INKEY$)
LOOP UNTIL i$ = "y" OR i$ = "n"

IF i$ = "y" THEN
  PRINT "Yes"
  PRINT
ELSE
  PRINT "No"
  PRINT
  PRINT "Goodbye ..."
  END
END IF

bytehex$ = MID$(hxm$, 1, 2)
hl = 2
hx$ = bytehex$
GOSUB gethexnum
s$ = "WR 00 04" + STR$(number)
PRINT s$
PRINT #1, s$
GOSUB readresponse
PRINT #1, "RD 00 04"
GOSUB readresponse
IF result$ = "Done." THEN
  IF bytehex$ <> value$ THEN
    PRINT "Error - read "; value$; " back."
    END
  END IF
END IF

bytehex$ = MID$(hxm$, 3, 2)
hl = 2
hx$ = bytehex$
GOSUB gethexnum
s$ = "WR 00 05" + STR$(number)
PRINT s$
PRINT #1, s$
GOSUB readresponse
PRINT #1, "RD 00 05"
GOSUB readresponse
IF result$ = "Done." THEN
  IF bytehex$ <> value$ THEN
    PRINT "Error - read "; value$; " back."
    END
  END IF
END IF

bytehex$ = MID$(hxm$, 5, 2)
hl = 2
hx$ = bytehex$
GOSUB gethexnum
s$ = "WR 00 06" + STR$(number)
PRINT s$
PRINT #1, s$
GOSUB readresponse
PRINT #1, "RD 00 06"
GOSUB readresponse
IF result$ = "Done." THEN
  IF bytehex$ <> value$ THEN
    PRINT "Error - read "; value$; " back."
    END
  END IF
END IF

bytehex$ = MID$(hxc$, 1, 2)
hl = 2
hx$ = bytehex$
GOSUB gethexnum
s$ = "WR 00 07" + STR$(number)
PRINT s$
PRINT #1, s$
GOSUB readresponse
PRINT #1, "RD 00 07"
GOSUB readresponse
IF result$ = "Done." THEN
  IF bytehex$ <> value$ THEN
    PRINT "Error - read "; value$; " back."
    END
  END IF
END IF

bytehex$ = MID$(hxc$, 3, 2)
hl = 2
hx$ = bytehex$
GOSUB gethexnum
s$ = "WR 00 08" + STR$(number)
PRINT s$
PRINT #1, s$
GOSUB readresponse
PRINT #1, "RD 00 08"
GOSUB readresponse
IF result$ = "Done." THEN
  IF bytehex$ <> value$ THEN
    PRINT "Error - read "; value$; " back."
    END
  END IF
END IF

bytehex$ = MID$(hxc$, 5, 2)
hl = 2
hx$ = bytehex$
GOSUB gethexnum
s$ = "WR 00 09" + STR$(number)
PRINT s$
PRINT #1, s$
GOSUB readresponse
PRINT #1, "RD 00 09"
GOSUB readresponse
IF result$ = "Done." THEN
  IF bytehex$ <> value$ THEN
    PRINT "Error - read "; value$; " back."
    END
  END IF
END IF

PRINT #1, "reset"
PRINT "reset"

PRINT
PRINT "Done."


CLOSE #1


END


' --------------------------------------------------------------

readresponse:

value$ = ""
result$ = ""
DO
  line$ = ""
  DO
    c$ = INPUT$(1, 1)
    IF c$ <> CHR$(13) AND c$ <> CHR$(10) THEN line$ = line$ + c$
  LOOP UNTIL c$ = CHR$(10)
  IF RIGHT$(line$, 1) = "." THEN
    result$ = line$
  ELSE
    value$ = line$
  END IF
LOOP UNTIL result$ <> ""
IF result$ <> "Done." THEN PRINT result$: END
RETURN

' --------------------------------------------------------------

gethexnum:

number = 0
hx$ = LCASE$(hx$)
FOR l = 1 TO hl
  number = number * 16
  m$ = MID$(hx$, l, 1)
  IF m$ >= "a" THEN
    number = number + ASC(m$) - ASC("a") + 10
  ELSE
    number = number + ASC(m$) - ASC("0")
  END IF
NEXT l
RETURN

' --------------------------------------------------------------

float2number:

hx$ = LEFT$(hxnum$, 2)
hl = 2
GOSUB gethexnum
ex = number - 127

hx$ = MID$(hxnum$, 3, 4)
hl = 4
GOSUB gethexnum
IF number > 32767 THEN
  number = number - 32768
  sign = 1
ELSE
  sign = 0
END IF

fraction# = 1
fracdiv# = .5
divide = 16384
FOR l = 1 TO 15
  IF number > divide THEN
    fraction# = fraction# + fracdiv#
    number = number - divide
  END IF
  divide = divide / 2
  fracdiv# = fracdiv# / 2
NEXT l

IF sign = 1 THEN fraction# = -fraction#
number# = fraction# * (2 ^ ex)

RETURN

' --------------------------------------------------------------

number2float:

' Find exponent for floating point format
b0 = INT(LOG(ABS(num#)) / LOG(2))

' Now find fractional part
fraction# = (ABS(num#) / (2 ^ b0)) - 1
IF fraction# < 0 THEN PRINT "Error!": END
divide# = .5
IF num# < 0 THEN b1 = 1 ELSE b1 = 0
FOR l = 1 TO 7
  b1 = b1 + b1
  IF fraction# >= divide# THEN
    b1 = b1 + 1
    fraction# = fraction# - divide#
  END IF
  divide# = divide# / 2#
NEXT l
b2 = 0
FOR l = 1 TO 8
  b2 = b2 + b2
  IF fraction# >= divide# THEN
    b2 = b2 + 1
    fraction# = fraction# - divide#
  END IF
  divide# = divide# / 2#
NEXT l

' Done - output result
hx$ = HEX$((b0 + 127) * 65536 + b1 * 256 + b2)
RETURN


' --------------------------------------------------------------


