CLS
PRINT "Converts number into Microchip 24 bit format (see AN575)"
PRINT "R.Hunt"
PRINT "April 2nd 2000"
PRINT

INPUT "Convert to (F)loat or to (N)umber"; t$
IF LCASE$(t$) = "f" THEN GOTO tofloat

PRINT
LINE INPUT "Enter six digit hex number: "; hxnum$
hxnum$ = LCASE$(hxnum$)

hx$ = LEFT$(hxnum$, 2)
hl = 2
GOSUB gethexnum
ex = number - 127

hx$ = MID$(hxnum$, 3, 4)
hl = 4
GOSUB gethexnum
IF number > 32767 THEN
  number = number - 32768
  sign = 1
ELSE
  sign = 0
END IF

fraction# = 1
fracdiv# = .5
divide = 16384
FOR l = 1 TO 15
  IF number > divide THEN
    fraction# = fraction# + fracdiv#
    number = number - divide
  END IF
  divide = divide / 2
  fracdiv# = fracdiv# / 2
NEXT l

IF sign = 1 THEN fraction# = -fraction#
PRINT "Number = "; fraction# * (2 ^ ex)
END


gethexnum:
number = 0
FOR l = 1 TO hl
  number = number * 16
  m$ = MID$(hx$, l, 1)
  IF m$ >= "a" THEN
    number = number + ASC(m$) - ASC("a") + 10
  ELSE
    number = number + ASC(m$) - ASC("0")
  END IF
NEXT l
RETURN


tofloat:

PRINT
INPUT "Enter fractional part (inc. sign bit)"; num#
INPUT "Enter exponent"; ex

originalnum# = num# * (10 ^ ex)


' Find exponent for floating point format

b0 = INT(LOG(ABS(originalnum#)) / LOG(2))


' Now find fractional part

fraction# = (ABS(originalnum#) / (2 ^ b0)) - 1
IF fraction# < 0 THEN PRINT "Error!": END

divide# = .5

IF originalnum# < 0 THEN b1 = 1 ELSE b1 = 0
FOR l = 1 TO 7
  b1 = b1 + b1
  IF fraction# >= divide# THEN
    b1 = b1 + 1
    fraction# = fraction# - divide#
  END IF
  divide# = divide# / 2#
NEXT l

b2 = 0
FOR l = 1 TO 8
  b2 = b2 + b2
  IF fraction# >= divide# THEN
    b2 = b2 + 1
    fraction# = fraction# - divide#
  END IF
  divide# = divide# / 2#
NEXT l


' Done - output result

PRINT "24 bit Microchip float = "; HEX$((b0 + 127) * 65536 + b1 * 256 + b2)

