History
-------

21/01/00        Project created from weather station.


25/01/00        Continued to re-cycle old code from Mandy.  Introduced EEALLOC include
                file and planned EEPROM storage.  DATA module also now sensible.


29/01/00        Finished updating main.asm; concluded eealloc.inc.


30/01/00        Moved eeprom routines into own module, along with update_baro.
                Add barograph and airtime timers
                Implemented update_baro
                Concluded updating old code - now well stuck into writing new stuff!


03/02/00        Added intialisation of variables from eeprom
                Tidied up data structures and moved some stuff to bank 1


31/03/00        Started tidying up variable references and banks

01/04/00        Finished tidying up (banks sorted etc.)
                Replaced PG polar curve with a HG VB one!
                Calculated polar curve values from guess of HG performance
                Added variables for altitude, vario, tas and temperaure!
                Corrected some variable names and 24 bit code
                Added R8, R9, R10 to keep life easy!

03/04/00        Implemented cmd0

04/04/00        Made wait_10ms available globally (for use by engineering module)
                Replaced ENG_ERR and NUMBER with R11 and R12 in UART routines
                Added R11, R12 to bank 0
                Concluded UART routines

09/04/00        Add R13, R14, R15 and R16 to bank 0
                Turned PRS_C into a signed 16 bit number
                Integrated required maths routines and finished calibrate routine

12/04/00        Implemented measurement routines

22/04/00        Added 32 bit norm, multiply, divide, add and subract routines together
                with R17-R28 in bank 1.  Needed for ...


25/04/00        Started building measure.asm node.


29/04/00        Converted over to PIC16C76 and built all nodes, split maths into two
                and added pagesel as so big (over 2K).

                Built first hex file ready for testing non-MMI routines.


14/05/00        Tested following maths routines:
                        multiplyfloat           OK
                        dividefloat             OK
                        fpm32                   OK
                        fpd32                   OK
                        fps32                   OK
                        fpa32                   OK
                        ln                      OK for positive results, WRONG on neg
                        power                   FAIL

                Power was because of simple error and also exp not working.
                However, complaining that node had changed - may have as .asm was
                later (possibly) than object.  Recompiled math.asm and rebuilt.


13/06/00        Altered break in ln function so works.


14/06/00        Found true fault in ln function - had pagesel after a btfsc in
                conv2float_signed routine.  So it was in fact a conv2float_unsigned
                routine!

                Restored break to how microchip did it


15/06/00        Found another bug in my nrm2424 routine - was checking R11 instead
                of R6 for sign.  Hence ln was wrong sign sometimes etc..

                Corrected paging problem in exp24 with some pagesels and moving
                _math2 section.  May be worth a tidy of pagesel sometime actually.

                All maths routines seem to work!  Yet to explicitely try all the
                float/int conversion routines but these will soon become apparent if
                they don't work.


19/06/00        Corrected small bug in conv2float_unsigned, was factor of two out
                Corrected some serious bugs iun conv2int_signed & _unsigned.
                Add labels to measure routines to aid testing


23/06/00        Altered measurement routine to work using floating point numbers now
                have the capability for adding and subtracting.  Much more accurate
                as well - was hopeless before.


27/06/00        Correct asipressure calculation for zero floating case result.


04/07/00        Corrected scaling constant in altitude calculation.
                Corrected timing in wait routines.
                Rename read_byte in measure.asm to read_adc_byte to avoid confusion
                with read_byte in ee.asm.


24/07/00        Started work on LCD code


16/10/00        Added cmd and data write routines and first 'FFC' test ...


21/10/00        Commented out sections of code so get up and running easier
                Corrected LCD routines (quite radically)
                Corrected interrupt init (enabled timer0 instead of periph interrupts)
                Correct timer interrupt code (was using bank 0 instead of bank 1)
                Added test beep to interrupt code for now
                Correct UART baud rate so correct for 4MHz crystal and not 16MHz!


22/10/00        Max UART speed on P16C73A is 2400 baud!  Set to this for now.
                Dump runs out of room in buffer (only 16 chars) - sort this sometime
                Uncommented more code in get-up-and-running process


10/12/00        Finally concluded why wasn't reading from adc correctly.  Was
                trampling on open-collector i/o by using bsf / bcf ops!

                Also corrected read_eeprom and write_eeprom routines which were
                initialising SDA output latch to high and not low.  Would have
                same problem :)


17/12/00        ADC still buggered - possibly.  Think may know why (again).
                Removed interface reset from code, still does it.  So checked timings
                again.

                Self-cal takes 452ms for a 20Hz update rate.

                Watchdog timer set to 576ms (1:32 prescaler).  However the prescaler
                may be reset on CLRWDT?

                Removed unnecessary clrwdt from code and changed those in main.asm
                to use a new routine (kick_dog) to restore the prescale value.


29/01/01        Altered dump so waits for empty buffer after each hex character rather
                than line.  Will work with all baud rates properly now.


05/02/01        Just do clrwdt again!
                Started work on draw_screen


06/02/01        Worked out big UDG characters required


07/02/01        Wrote draw_screen and program_udg code
                Started doing update_screen0 with big characters!


09/02/01        Did digitise routine


06/03/01        Finished update_screen0, adding couple more routines


08/03/01        Quick tidy of display_number and display_vario to remove trailing zeros
                Worked out what needed to go where for update_screen1


09/03/01        More work on lcd.asm


12/03/01        Completed screen 1 update, prepared for others.
                Added display_signed_word
                Renamed display_number to display_unsign_byte


19/03/01        Finished update screen routines
                Swapped order of initialisation in main.asm so reads in baro store
                to use before sets up pointers!
                Corrected 'send' command in uart.asm so doesn't have same problem
                'dump' originally did.


03/04/01        Added progress messages to boot-up


04/04/01        Wrote keypad handler


09/04/01        Started MMI handler, implemented screen change


16/04/01        Recompiled all nodes, removing compile errors


08/05/01        Shifted modules in memory so code fits into P16C76, all now linked
                ready for testing.

30/07/01        Removed bug from wait_1ms routine - called wait_5ms loop instead of
                its own wait_1ms loop.  As was not set up for this caused a very long
                delay (255 x 5ms) resulting in watchdog.

                Debugged reset_ext_adc (didn't pagesel wait_10ms)

                Debugged digitise routine


31/07/01        Concluded digitise routine debug
                Removed flaw in bignum execution (R0 corrupted, now use R6)


01/08/01        Changed pagesel macro where used for tables to explicit expansion.
                Compiler was using bsf and bcf for partial update of pclath instead
                due to processor type.  Hence wasn't updating all of pclath as
                required for a jump table!

                How cmd_table and cmd_jmp ever worked don't know!  bignum_table now
                works.


22/08/01        Missing bank select in initialisation, main.asm.


04/09/01        Work on LCD, now got displaying again.  Display does not show unless
                have cursor block flashing, and possibly underlined!

                Updated lcd.asm so uses LINE equates, and set so on correct lines
                for display!

                Now displays the first screen!  Does watchdog though :)

                Big chars look quite good!


05/09/01        Fixed problem with cursor on requirement!  Instruction is in fact
                00001DCB and not 00001BCD.  ie. I had the cursor blink and display
                on bits exchanged at the end of the reset_lcd routine :)

                Hopefully now sorted.


10/09/01        Sorted some incorrect banks.

                Commented out scheduler code to try and track down reset.  Suspect
                is overrange on bignum however, now trap this.  Seems to have fixed
                it for some reason.

                Tidied screen 0, started uncommenting code.


02/10/01        Investigations into why code resets on hw, but not in simulation


03/01/01        Implemented setpage macro in main.asm; suspect bitselect version of
                pagesel is reason for above.


27/12/01        Changed all pagesel to setpage.

                Fixed bugs in keypad handler.

                Discovered hardware (P16C73A) looks shagged.  Timer not working.


25/02/02        Was the PIC; PIC16C76 works as intended!

                Tidied config screen.
                Added 10ms timer so key debounce not too fast!


27/02/02        Fixed timer display.
                Fixed temperature display.
                Switched in conv2int for pressure.
                Corrected MAXTAS - is a byte not a word!
                Combined UART and DATALINK flag into MMIFLAGS.5


28/02/02        Initialised S2F to zero.


01/03/02        Reset TEN_MS_TICK, and initialise to zero.
                Change MAXQFE to MAXALTITUDE
                Added MAXALTITUDE and MAXTAS update


05/03/02        Corrected bug introduced into LONG_DEBOUNCE.
                Corrected screen keypress handling (goes through correct set now)


07/03/02        Corrected vario calculation.
                Added vario averaging buffer.
                Initialised all vario variables.
                Added new PEAK_VARIO_TICK second countdown.
                Fixed lsb and missing 'm' for pressure
                Fixed display of : on timer
                Shuffled SND/TMR/DL right a space
                Shuffled TAS left a space
                Correct display of vario
                Fixed display of barograph rate
                Added peak and average vario code
                Intialise nShutdown according to MMIFLAGS on boot-up


08/03/02        Fixed infinite loop bug introduced in vario yesterday
                Wrote eeprom image download program


10/03/02        Fixed temperature display bug (had 26 and not d'26')
                Fixed big altitude display, R1R0 corruption!
                Fixed a bug found in the beep display, wrong bank
                Fixed incorrect bank usage when initial reads from eeprom
                Tweaks on display: TEMP renamed TMP, rate and max qfe shifted
                Added code to skip leading zeros on big alti and vario


11/03/02        Discovered that incf and decf don't affect carry flag!  Altered
                btfsc status,c instructions relying on this to btfsc status,z.
                Affected:
                        Vario rate
                        Altitude / pressure calculation
                        Signed number display
                        Eeprom read and write
                        UART interface
                Not bad eh?

                Corrected temperature use and now store as signed byte.  Was in
                fact 38 which was 0 degrees C, not 26 (which is the hex!).

12/03/02        Commented out service uart so works.  Suspect need to take maxim
                ic out of shutdown while interrupts disabled, clear them, then
                re-enable.

                Corrected big number skipping leading zero display.

                Fixed bug in digitise (didn't do ten thou correct, simple mistake)


13/03/02        Clear any rx errors before start interrupts going.

                Add pre-processing of received char to rx uart handler - throw
                away character if not 10, 13 or in the range 32 to 122 inclusive.

                Display just a large minus now for sign on big altitude and vario.

                Correct display_signed_number; corrupted R1R0 before saved it!

                Corrected display_vario.  Similar corruption and the cause of the
                rogue - signs being written across the screen!  Didn't move to
                position until after writin the sign.  Obvious in hindsight - vario
                is written after S2F!

                Corrected display of large altitude, leading zero stripping was
                incorrect.


14/03/02        Corrected position of vario display, now displays the sign!

                Disable rx interrupts when service uart, could cause errors or
                maybe even be the cause of crashing the code.

                _engtbl section wasn't in linker file; but _engtable was.  So
                probably wasn't in its own section or not in at all!  Probably
                why was crashing rather than interrupt possibility.  Sorted this.
                Also removed _mmijump as didn't seem to be used any more and
                needed extra bytes for rom_a.


15/03/02        Still resetting, found another reason - had initialised UART
                buffer in wrong bank.  Buffer also too long (16 in hex and not d'16').

                Both fixed, fingers crossed ...  WORKS!!!  And have comms again!


16/03/02        Worked on MMI, added all actions and processes; including
18/03/02        barograph stuff.
19/03/02
                Moved to 19200 baud as cannot get 9600 baud with 4MHz PIC.

                Store barograph pointer on eeprom when finish trace,
                restore on init.


20/03/02        Use of pagesel in mmi.asm causing problems (hence didn't work) so
                changed to setpage.  Which should of course have been using!

                Also updated uart.asm which had some explicit setpagse code which
                replaced with setpage.

                Returned to 2400 baud, 19200 doesn't seem to like 4MHz PICs!
                Didn't work with PIC16C73A either (earlier in the project).

                Corrected testing of valid keys on entry to do_mmi code.


25/03/02        Replaced all spacing with tabs (set to 8) to reduce file sizes
                and make all the same.

                Added explicit display update to FLAGS.  MMI code can now also
                use this to give more responsive screen updates.

                Added CURSORPOS and code so cursor displayed in correct
                position now, and doesn't move with screen update!


26/03/02        Tweaked cursor move code, now toggles between : and =
                Fixed couple of MMI bugs


27/03/02        Fixed display cursor (data not cmd!), put in correct positions
                Fixed display number so left flushes properly


31/03/02        Correct rd and wr routines so address correct.
                Coded fix for rapid-fire.


01/04/02        Were not sending device/upper address correct to eeprom.  Sorted
                this and tided up read/write routines.  Also added necessary 10ms
                routines to terminate_baro and so forth.

                Swapped dec2word byte order so returns R1R0 in line with rest of
                program.  Adjusted calling code as required.


02/04/02        Quick and easy fixes:
                        calc_hex broken above when half-moved to R8
                        rapid-fire of minus key
                        timer toggle

                Altered rd and wr commands so supply bytes rather than decimal dibits

                Added ADC (adc) (channel) command for internal and external ADCs.


03/04/02        Found and fixed memory stomp into Rx buffer.  Writing to R22
                at one place in math.asm was bank 0 instead of bank 1 because of a
                typo.  Instead of writing to 0xC7 wrote to 0x47 - rx buffer!

                Fixed bug in new adc command, didn't copy channel number to R2
                correctly.


04/04/02        Fixed bug in external adc read_word routine; ended up going to
                read_byte when waiting for interface to be ready.

                Fixed storing of MMIFLAGS - loaded from wrong bank, again!

                Altered temperature zero degrees point to that of LM335Z.  Existing
                TC02 sensor turned out to be 0 degrees at 0 volts and needed a
                negative rail.  The LM335Z device usefully has an offset of 2.73V.

                Rewrote key handler so neater and can now use "waiting for release"
                flag properly.


04/04/02b       Fixed small bugs introduced above!


06/04/02        Corrected storing of QFE_OFF and QNH_OFF bug.

                Altered write_eeprom_16 and write_eeprom_24 routines to write
                individual bytes rather than use page write method.  Do not know if
                will be on an eeprom 32 byte boundary!

                External adc read was one bit out, not that it will help much!


09/04/02        Renamed scheduler1b and scheduler1c - think MPASM only sees first
                10 digits but MPSIM sees more.  Hence sim OK but only does mmi update
                every 250ms.  Well, good theory anyway ... didn't work.

                Subsequent look suggests that is just loading as a consequence of
                something I've done.  Try regressing out routines sometime (02/04/02 ok)


24/04/02        Altered calibration of external adc more like datasheet to try to
                get working.  Also poll for nADCREADY before commence read from
                register.  Added a NOP between read clocks in case was pipeline problem.

                Added retries to eeprom read/write.  Left 10ms delays in for now.


02/05/02        Changed from HS mode to XT mode for 1/10th current consumption!

                Changed ADC update rate from 20Hz to 100Hz (FS from 00 to 10 for ADC).
                Expect 1.7lsb noise for Vref=2.5V, Vdd=5V, gain=128


03/07/02        Removed datalink and nShutdown
                Moved nADCCS to RC5
                Moved ADCDATA to RA5
                Made RA2 an analogue input for VARIO; also making RA5 analogue
                in the process unfortunately.  Need 10kohm input resistor on RA2 as
                need to make output (so stable digital state) when select RA5/RA2
                in digital mode.
                Altered external adc gain from 128 to 4.
                Moved PRS_C and PRS_M to bank 1
                Renamed to ALT_C and ALT_M; added ASI_C and ASI_M and modified code
                accordingly.


04/07/02        Rebuilt and relinked.


11/08/02        Corrected input/output direction of VARIO_ADC in external adc
                write_byte and read_word routines.  Had the incorrect sense.


12/08/02        Moved vario to start of measure routine for increased settling time
                Corrected bug where was -128 and not -d'128' in measure.asm
                Corrected vario peak detect

                Changed alt/asi update rate from 100Hz to 20Hz


28/08/02        Added 16 word adc averaging buffers

                Changed adc update rate back to 100Hz, actual output rate is thirs of this
                as need to read both channels and have filter settle.

                Change adc to unbuffered mode for lower current consumption; don't need as
                high an impedance now working from op-amp / potential divider outputs.  Need
                to verify this with oscilloscope, may need buffer on potential dividers
                setting -ve inputs for alt and asi.  Cheap tl082 do the job?


29/08/02        Now call measure every time external adc has an update.  Planned schedule
                of measure activity based on this tick.

                Next job to implement this in measure routine and modify altitude to read
                into and use adc averaging buffers.


09/09/02        Changed to RC oscillator so can use OSC2 for 1/4clk output to AD7705
                to overcome its noisy oscillator problem.

                Switched off oscillator (ie. MCLK OUT) on AD7705 as now supplying it
                with clock derived from PIC on MCLK IN.

                Returned to buffered mode for now; need to switch to unbuffered after
                everything else working.


11/09/02        Further work on modifying measure.asm routine.


12/09/02        Concluded measure.asm mods ready for compiling and simulate.
                Remapped object codes in ROM so fitted in.


13/09/02        Minor twiddle and simulate.
                Added decimal place precision to calibration.


14/09/02        Added cmd6 comment in uart.asm
                Fixed bug in average buffer (fell for the incf carry trap again!)
                Added now necessary wait for nADCREADY for adc command.
                Extended DUMP into banks 2 and 3.


16/09/02        BIG CHANGE to sort adc problems.  Result will be correct alt readings,
                asi impact pressure directly, and accurate temperature:

                Fixed read_ext_adc by adding wait-for-nDrdy; hopefully works again now!
                Fixed uart adc command
                Created gpio.inc to avoid equate duplication in files
                Removed magic numbers from writes to AD7705, replacing with equates
                Swapped calibration order so channel 0 left selected when exit
                Changed temperature sensor to be on channel 1 of external ADC
                (but not display code yet)
                Changed asipressure to work from internal adc (formerly used for temperature)
                Removed reads of asipressure from scheduler (wouldn't have worked as
                only one conversion can happen at a time, hence need for this big
                change).
                Changed ASI_M use, and removed ASI_C


17/09/02        Made scheduler frame 33 ticks rather than 32 ticks long.
                Added in temperature frame
                Made external adc unbuffered
                Added gain setting code and use by uart.asm and measure.asm


18/09/02        Finished coding for temperature frame
                Modified temperature display for new format


23/09/02        Added couple of missing bank selects in measure.asm following simulation.


25/09/02        Test latest software and hardware:
                        Clock is 1.008MHz x 4
                        Temperature now calibrated (works well!)
                        Unbuffered drain into ADC is 3ua
                Need to change scheduler and rate as does occur at full rate, just
                misses two outputs when change channels.


26/09/02        Modified hardware in effort to reduce noise:
                        Moved R29 +ve connection from pin3 alt to pin9
                        Moved R30 -ve connection from pin1 alt to pin10
                        Capacitor (10nf and 1uF) across pins 9 and 10
                        Moved sensor ground connection join to pin 16 of ad7705 (dgnd)
                        Moved R27 +ve to IC2.4 supply directly
                        Moved R28 -ve to IC2.11 gnd directly
                        Shielded AD7705 on top (copper tape)
                        47uF between pins 9 (+ve side) and 10 of IC3 improves things
                Still noisy but 47uF has biggest effect on vario.  Waggly though,
                need to improve final stage amplification I think.


27/09/02 am     Re-jiggled scheduler to 25Hz, reading temperature every tenth frame
                on ticks 13 to 18.  Altered ADC reads so just wrap round a 16 word
                buffer irrespective.

                Found reason why altitude wasn't being updated - it wasn't being
                called from the scheduler!

                Now subtract 127 from ASI reading in readiness for my cunning
                re-working of the vario circuit (need to nab an op-amp from the
                asi circuit leaving it a single-ended reading from differential
                output).

                Fixed UART-not-working bug (forgot a bcf status,irp)

                Updated default value for ASI muliplier.


27/09/02 pm     Fixed bug introduced above, didn't set update screen on temperature
                scheduler tick 13 (minor bug!).  Fixed bug in that didn't read and
                store pressure adc also, result was temperature reading incorrect as
                taking FSYNC resulted in it waiting for a read.  I think.

                Changed ADC gain to unity, as moving back to differential scheme.
                About to rework hardware for this and improved (hopefully) vario.  Can't
                get any worse!

                Update coeffients in download.bas and default ones in main.asm.
                Reprogrammed in eeprom.

                Removed single ended fudge for asi introduced above, above hardware
                change will leave us an op-amp to do diff to single conversion.

                Testing:  Temperature works again now, and pressure alters as
                          expected when muck about with coefficients.  Hardware next
                          then!  Still funny on power-on now which didn't used to
                          get.  OK if type RESET though.


29/09/02        Got modified hardware (from yesterday) working.  Altimeter works anyway!
                In theory vario should but isn't and need to look at with scope.

                Took reading for 1026mbar and (after altering some scaling in hardware)
                coded into software for default value of m.  Altered back to BUFFERED
                mode and made altimeter a gain of two (hence the hardware twiddle).

                Move to 19200 baud rate, noticed had completely wrong number for baud
                rate generator previously!



01/10/02        Vario seems to work!  Swapped round R and C of differentiator (so
                can also use as integrator for altitude now as well!) in attempt
                to reduce noise.

                Then noticed an incorrect connection hanging off pin 1 of IC2 (ie
                altitude output).  Noise disappeared but ADC now over-range as not
                so loaded any more!  Also unsnipped very long resistor leg which
                could have been causing problems.  Forgot to snip when soldering
                it in a while back now ;)

                Need to twiddle scaling again, fix watchdog-ing out on startup, and
                start investigating barograph.

                Yipee!


02/10/02        Ermm, was only working because had disconnected feedback resistor from
                pin 1.  Shows is amplifying genuine signal rather than noise though.

                Consequently I've altered the gains again.

                Moved clrwdt for measure routine in scheduler to before check.  Think
                is watchdog-ing out when changing adc channels (ie. when reading
                temperature for first time on startup after doing other stuff).

                Fixed display of QNE, had the endian of the word bytes wrong in lcd.asm.


03/10/02        Found bug in scheduler on startup (lacking a setpage)

                Merged in new barograph code.

                Returned to unbuffered

                Remapped where code is to allow for growth!


06/10/02        Tidied up scheduler

                Added and implemented use of separate update flags for QFE and QNH to
                allow for fast or rapid-fire setting of indicated height using keys.

                Changed timer 1 use of prescaler 1:1, slightly more accurate now as well.


08/10/02        Finished work on SEND.  Altered end of barograph enumeration to
                a 5-byte boundary; when reach here have "gone too far".


09/10/02        Debugged SEND.
                Now cease barograph storing when reach end of buffer.
                No longer write ffffffffff if at end of buffer and user ends timer.
                Added end of barograph variable to make life easier!


10/10/02        Added barograph entries remaining to screen 3 display.


18/10/02        Now initialise end of barograph variable!
                Recalculated ALT_M based on previous reading.
                Fixed bug in new SEND (did not copy to R0 before send_char).
                Changed send_char so takes wreg and not R0, thus saving many bytes
                of program space.


30/10/02        Corrected last digit of barograph remaining (had addwf instead of addlw)
                Added missing ,f to decfsz BARO_LEN in ee.asm
                Added missing ", " to SEND command output
                Fixed initialisation of barograph end pointer variable
                Added initialisation of BARO_P to download.bas
                Corrected mmi screen 3 so now stops barograph, resets pointer, and
                immediately writes to eeprom when change barograph in use.


2/11/02         Updated circuit diagram with latest vario circuit!

                Changed back to buffered mode as noise on sampling reads (2x1MHz/64)
                wreaking havoc with the differentiator.

                To get in buffer limit (Vdd-1.5V) altered gains ao 1050mbar is
                now 3.5V; and set Vref to be 3.5V instead of 5.00V.

                Rescaled temperature adc processing as now 5V/3.5V greater.  Don't
                have to alter pressure adc as 1050mbar is still maximum adc reading.

                Fixed bug noticed in measure.asm - hasn't been calibrating temperature
                adc for correct gain as forgot to use new equate instead of fixed GAIN_x.


3/11/02         Altered op-amp gains, yet again!  Forgot that although within ad7705
                buffered in headroom spec was outside of op-amp output capability!
                Can't go within 1.2V of rail so therefore altered back so 1050mbar is
                2.5V.  Vario circuit adjusted back accordingly.

                Kept yesterday's modifications otherwise the same except now reduce
                Vref from 3.5V to 2.5V.  Also take Ain2- (temperature) to this instead
                of ground to subtract 2.5V from the temperature output and bring
                within range of adc again.

                Modified temperature calculation in software accordingly.

                Fixed vario reading, was putting into 1s complement rather than 2s
                which display and everything else was expecting.  Hence eratic
                reading, not noise (completely) after all!

                Found bug - had missed off ,f from barograph pointer compare in ee.asm;
                so was altering it instead of doing its job.

                Found a bug in barograph, got rid of that and had bit of a tidy as
                well.

                Found *real* reason barograph wasn't storing.  It actually was,
                just lots of TAS for the first five frames!  Forgot that the
                default case was return and didn't bother checking if it was the
                tick for storing TAS.

                Altered CAL command to use most pressure adc buffer average.


6/11/02         Fixed temperature output in SEND bug (forgot to load it into R1R0!)


23/02/03        Disabled portb pull-ups.  Could be causing capacitive overshoot/
                undershoot problems on display enable lines - the source of noise on
                the voltage and battery rails!


24/02/02        Didn't work, oddly enough.  Will add pull-downs / termination on
                lcd and sclk lines to avoid current gloop.

                However, to help reduce current surge modified software so changes
                outputs one at a time.


19/04/03        Updated default pressure sensor calibration (m and c) values

                !!!!!!!!!!!!!! ALTIMETER AND VARIO BOTH WORK !!!!!!!!!!!!!!!!

                For the first time in three years both altimeter and vario now work!
                Altimeter needed couple of twiddles to circuit for new sensor and
                get resolution of 2 / 3 feet without any flicker.  Vario needed
                first part of circuit removing, gains modifying for new sensor,
                and capacitive smoothing added (CR being set to 0.22).

                Barograph also works!  Well, mostly.  Now need to do the following:

                        - Update circuit diagrams and pcb for next spin (if do one)
                        - Baro gives altitude, vario (avg?), -35(temp was 25), 131??
                        - Need to fix vario peak and average
                        - Need to sort out timer auto start/stop
                        - Need to fix bugs in barograph screen
                        - Need to add beeps to vario!!!

                Phew.


27/04/03        Improved cal of alti based on readings from AT&T online station in
                Cambridge.  Seems that we agree except for offset so have added 4.5mbar
                to c.  Not a bad first stab really!

                Now confident in that, need to stand next to a station and
                calibrate to a tenth of a mbar.  Maybe a trip to the discovery store
                with altimeter discretely secreted ;)


28/04/03        Debugged peak detect and speeded up time constant so timesout previous
                peak if hasn't been topped for five seconds.


02/05/03        Fixed a bank select bug in barograph mmi screen.
                Corrected barograph temperature output when "SEND"
                Changed barograph to store AVERAGE_VARIO rather than VARIO


07/05/03        Fixed barograph screen bug where display goes funny (sent cmd rather
                than data in hide cursor).  Still problem when write past a minute
                for barograph (screws up) and need to change +5V regs to LDOs.

                Migrated to latest version of MPLAB for fast simulation.

                Fixed end-of-barograph check bug which probably caused the failing
                barograph problem.


08/05/03        Fixed terminate-barograph problem surprisingly quickly!  Had
                ommitted ,w from a subwf so did a search and checked (and fixed) some
                others as well.


22/05/03        Put in code to slow down rapid keypresses.
                Fixed store of vario reading - was in wrong bank.
                Fixed hide cursor - now does : instead of blank


10/07/03        Modified barograph so stores baro rate in end marker.  This is now
                sent out as the last number on SEND.

                Improve barograph screen, now show barograph store in use and
                time remaining (instead of words can store).  To save processor time
                only do this if need to (on barorate change, store change, or
                barograph finished updating).

                Not yet compiled or tested though!


16/07/03        Compiled after couple of simple typos sorted.
                Removed Tetris screen to provide some more memory.
                Optimised code in lcd.asm by adding nibble latch routine and repeat
                calls to send_data without reloading wreg.
                Added temperature compensation to vario (needed as 2.5V ref drifts).


17/07/03        Debugged temperature compensation using simulator.
                Fixed bug in existing calculation for barograph remaining.
                Debugging time remaining new functionality.


21/07/03        Finished debugging time remaining on simulator.
                Found bug in temperature adjustment (was adjusting the wrong way!)
                Fixed bug in optimised send_8bit_cmd/data code (need to use return
                and not retlw!) but seemed all to work first time apart from that!


22/07/03        Update barograph time remaining when change barograph rate.

                Added correct TAS calculation (yet to compile or simulate).  Also added
                ASI_C factor so can have impactpressure = m * adc + c for asi.


28/07/03        Set default value for asi_m.
                Ran IAS and TAS calculation through simulator and debugged.


29/07/03        Removed polars and ias table (no longer going to be used)
                Changed S2F to glide angle
                New layout for main display to accomodate glide angle and distance
                Added display of glide information


30/07/03        Compiled and simulated - fine.
                Added s2f angle calcs, compiled and linked.
                Simulated and fixed glide angle calculation, now just need to do
                distance.

31/07/03        Moved ASI_M/C and ALT_M/C to bank 0 now have space, and for more efficient
                code.  Finished simulation and now ready to test!

11/08/03        Added vario beeps into software.

12/08/03        Simulated and fixed minor bugs in beep.

27/08/03        Fixed continuous beep problem - mmiflags is in bank 1
                and was reading from bank 0 in interrupt routine.

                Also simulated a new piezo drive circuit which will work this time.  Previous
                circuit was for inductive rather than capacitive loads.  A piezo
                disc has a capacitance of 18 to 30nF.


30/08/03        Implemented new hardware circuit - a lot better but still room for
                improvement (sharper edges for greater dB?).  Fixed bug in beeper
                software and calculation.

                Modified audio thresholds to 0.6up, 1down and dropped output
                frequency.

                Fixed bug in barograph - never advanced pointer in memory past
                marker.  Note bugs remaining if reach end of trace yet to resolve ...


07/09/03        Implemented vario using alti adc instead of analogue circuit.  No zero
                or drift to worry about and same accuracy.  A little slower in frequency
                of update but no big deal.  Reliable!

                Changed sounder so 120ms on, 130ms off going up; and 170ms on, 80ms off
                when going down.


08/09/03        Fixed possible problem in 16bit adc read - lacking pipeline when read
                the lsb of word.  Also halved averaging period if DIGITAL_VARIO defined.


16/09/03        Add auto start/stop functionality


17/09/03        Fix bug in glide distance calculation causing alti to reset.


21/09/03        Average previous four samples for use by digital vario instead
                of just taking a spot (noisy) reading.  Same lag as would have from
                an analogue implementation.

                Fixed bug in adc read - was reading bits after taking SCLK high. This
                was fine for all except the LSB bit which only has a hold time of up to
                100ns.  LSB was always therefore stuck high.  Now modified so read bit
                before take SCLK high.  Should be a bit more accurate now and digital
                vario less noisy.

                Fixed peak vario detect.


03/10/03        Updated schematics ready for final board spin.  Now have pitot
                tube circuit on board, latest pressure sensors and voltage regulators
                and so on.  Also, as now are just using altimeter for vario can use
                VARIO pin for output.  This is now used for switching on and off the
                temperature sensor so better current consumption and no self heating
                problems.


21/10/03        Remove non-DIGITAL_VARIO code thus making digital vario core code.  Will
                be easier to maintain this way and can also reduce size of vario averging
                buffer.

                Now using digital vario; remove use of RA2 as analogue input and all the
                necessary reconfiguration of ADCON1 that involved.  Instead use as a
                digital output nMeasure for switching on and off the temperature sensor.
                This will remove problems with self heating and save current.


8/12/03         Change config word to XT oscillator


13/01/04        Enabled AD7705 clock again as going to need both clocks running.  Not sure
                whether dodgy proposed scheme is going to work or be of any benefit.  Only
                till MX7705 comes out anyway.


14/01/04        Old software runs on hardware whereas new stuff doesn't!  Something to
                go on at last.
                
                
15/01/04        Found bug - I'd miss out a switch back to bank 0 when removing the old ADCON1
                changeover code.  Now can start making progress again.
                
                All runs as before, seems fine!  Audio works, temperature works, uart works.
                
                Tried out CAL command, doesn't work.  No real suprise.  Need to test on
                simulator.
                
                
22/02/04        Decided to implement calibration on PC.  Not only is this quicker to sort
                but also frees up more program space on PIC (onboard routines no longer
                required).  Removed and recompiled.  Need to do PC app but should be
                fairly simple in floating point basic!


29/02/04        Modified so starts writing current barograph entry immediately when
                start a timer.  Also now prevent writing if no more room left; and
                terminate when reach the end.

                Finally, change minimum baro rate to every second (possible as writes
                all synchronised to adc tick and take less than a second) and rebuild.

                Now just need to test out the barograph!


02/03/04        Made one small fix to barograph but not writing terminator all
                the time.  Also doesn't seem to like writing to barograph 2.


4/03/04         Fix terminate barograph, had pointer and end of buffer compare the
                wrong way around.


13/04/04        Physically move centre key in caseworks so can press with gloved hand.


15/04/04        Modified timer auto start/stop so has to beep for three seconds
                continually before starts/resets the timer.
                
                Reduce time when quiet from 2 minutes to 30 seconds for timer to stop.
                Quiet is now no beeps for three consecutive seconds.

                
18/04/04        Fixed bug where would watchdog when searching for the end of a long
                trace in SEND command.  Had clrwdt in wrong place.
                
                Recalibrated altimeter now a low pressure system has moved through.
                
                Implemented new loud piezo circuit.
                
                Fixed bug so now clears pwm output pin to zero when stop pwm-ing.
                Otherwise left in high state by bit ups on portc while pwm operational.
                
                Dropped pitch of vario by 200Hz, made continuous when going down
                and extended beep on period when going up.


19/04/04        Updated schematics, PCB, and website


22/04/04        Fixed so marks end of barograph if runs out of memory.
                Changed barograph so stores QFE and not QNH, more useful.
                

25/04/04        Separated out timer start/stop vario thresholds and sounder beeps so
                can configure latter.  Modified so only beeps if < 2 down; still beep
                up if > 0.6up.  Timer thresholds are 1 down and 0.6up.


26/04/04        Changed tones from vario so dropped even more for going up.  Made possible
                as going down beeps are now simplified and as far down as they can go.
                
                Display average vario as large vario and most recent reading in small
                print; too rapid changes confusing to look at when flying and meaningless
                as air isn't really doing that necessarily.  Use the force instead!
                
                Beep using averaged vario instead of instantaneous reading.
                
                Add partial update readings into average; average time now previous
                four seconds.  Doesn't matter losing our 1 bit of accuracy as will
                average out and close enough!


27/04/04        Modified down beeps so now even lower; do this by changing prescaler
                to 1:16 when going down.
                
                Ensure only write to t2con if need to otherwise cleares prescale counter.
                
                Also, only reload period if changed as this may also affect things if
                continually beeping and being 'reloaded'.
                

29/04/04        Changed buzzer to KPE116 as better match in frequency response (ie. louder)
                for new frequencies.


07/08/04        Dropped in pressure sensor for pitot tube and worked first time!  Check
                accuracy in howling gale on top of Mam Tor and also spot on.  Few twiddles
                to software and a new case and will be sorted.


09/08/04        Fix cursor bug on barograph screen; +/- when nothing selected now doesn't
                do anything.
                
                Add QNE to main display selection so now QFE/QNH/QNE.
                
                Zero air speed reading if adc is just 1; never reading 0 so previously
                always showing 4mph.
                
                If going up, zero glide distance rather than maxing it out
                
                
23/11/04        Added missing diode to piezo circuit and corrected duty cycle in
                software.

                
25/11/04        Biased diode adder in piezo circuit with 47k pull down and now finally works
                properly!  Full doublt Vbat swing across the piezo, returning to 0V at rest.
                Will take out for a fly this weekend to test in the air, already sounds
                better with 50% duty and a relatively flat (6.5V) battery.
                
                
28/11/04        Forgot to add a necessary extra diode into schematics to account for
                minimum voltage C27 gets down to (as a consequence of diode drops in
                rectification).  Now done, also renamed diodes.  Will update website description
                when next get chance.
               